<?php
declare(strict_types=1);

namespace Inti\Test\TestCase;

use Inti\Provider\ProviderInterface;
use Inti\Provider\Service\ProviderManager;
use Inti\Provider\Service\ProviderManagerInterface;
use Inti\Provider\Type\TypeInterface;
use Inti\Test\Constraint\Provider\CanProvide;
use PHPUnit\Framework\Assert;

/**
 * Trait ProviderTestTrait
 *
 * @package Inti\Test\TestCase
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-bartog
 */
trait ProviderTestTrait
{
    protected function createProviderManager(array $config = []): ProviderManagerInterface
    {
        $config[ProviderManager::class] = $config;
        $container = $this->createContainer($config);

        return $container->get(ProviderManagerInterface::class);
    }

    public function assertProviderCanProvide(TypeInterface $type, ProviderInterface $provider, string $message = '')
    {
        $providers = $this->createProviderManager([
            'registered' => [$provider],
        ]);

        $canProvide = new CanProvide($type);
        Assert::assertThat($providers, $canProvide, $message);
    }
}
